%global gem_name raindrops

%global rubyabi 1.9.1

Summary: Real-time stats for preforking Rack servers
Name: rubygem-%{gem_name}
Version: 0.8.0
Release: 6%{?dist}
Group: Development/Languages
License: LGPLv2 or LGPLv3
URL: http://raindrops.bogomips.org/
Source0: http://rubygems.org/gems/%{gem_name}-%{version}.gem
Requires: ruby(abi) = %{rubyabi}
Requires: ruby(rubygems) 
BuildRequires: ruby(abi) = %{rubyabi}
BuildRequires: ruby-irb
BuildRequires: rubygems-devel
#BuildRequires: rubygem(unicorn) will be included after bootstrapping unicorn
BuildRequires: rubygem(rack)
BuildRequires: rubygem(minitest)
BuildRequires: ruby-devel
Provides: rubygem(%{gem_name}) = %{version}
ExcludeArch:   ppc ppc64

%description
Raindrops is a real-time stats toolkit to show statistics for Rack HTTP
servers.  It is designed for preforking servers such as Rainbows! and
Unicorn, but should support any Rack HTTP server under Ruby 1.9, 1.8 and
Rubinius on platforms supporting POSIX shared memory.  It may also be
used as a generic scoreboard for sharing atomic counters across multiple
processes.

%package doc
Summary: Documentation for %{name}
Group: Documentation
Requires: %{name} = %{version}-%{release}

%description doc
Documentation for %{name}


%prep

%setup -q -c -T
mkdir -p .%{gem_dir}
export CONFIGURE_ARGS="--with-cflags='%{optflags}'"
gem install -V \
	--local \
	--install-dir .%{gem_dir} \
	--force \
        --rdoc \
        %{SOURCE0}

# Adjusting minor permissions
chmod a+r .%{gem_instdir}/ChangeLog
chmod a+r .%{gem_instdir}/NEWS
chmod a-x .%{gem_instdir}/examples/linux-listener-stats.rb

# Fixing test-suite files
sed -i '2 i\
require "rubygems"' .%{gem_instdir}/test/rack_unicorn.rb

sed -i '2 i\
require "rubygems"' .%{gem_instdir}/test/test_linux_ipv6.rb

sed -i '2 i\
require "rubygems"' .%{gem_instdir}/test/test_watcher.rb

%build

%install
mkdir -p %{buildroot}%{gem_dir}
mkdir -p %{buildroot}%{gem_extdir}/lib
cp -a .%{gem_dir}/* %{buildroot}%{gem_dir}/

# Remove the binary extension sources and build leftovers.
rm -rf %{buildroot}%{gem_instdir}/ext
rm -f %{buildroot}%{gem_instdir}/.document
rm -f %{buildroot}%{gem_instdir}/.gitignore
rm -f %{buildroot}%{gem_instdir}/.manifest
rm -f %{buildroot}%{gem_instdir}/.wrongdoc.yml
rm -f %{buildroot}%{gem_instdir}/GIT-VERSION-FILE
rm -f %{buildroot}%{gem_instdir}/GIT-VERSION-GEN
rm -f %{buildroot}%{gem_instdir}/GNUmakefile
rm -f %{buildroot}%{gem_instdir}/Rakefile
rm -f %{buildroot}%{gem_instdir}/Gemfile
rm -f %{buildroot}%{gem_instdir}/setup.rb
rm -f %{buildroot}%{gem_instdir}/pkg.mk
rm -f %{buildroot}%{gem_instdir}/raindrops.gemspec
rm -rf %{buildroot}%{gem_instdir}/.yardoc

# move header files, C extension files to the correct directory
install -d -m0755 %{buildroot}%{gem_extdir}
mv %{buildroot}%{gem_instdir}/lib/raindrops_ext.so %{buildroot}%{gem_extdir}/lib/


%check
cd %{buildroot}%{gem_instdir}
RUBYOPT="-Ilib -I%{buildroot}%{gem_extdir} -Itest" testrb test/test_aggregate_pmq.rb

RUBYOPT="-Ilib -I%{buildroot}%{gem_extdir} -Itest" testrb test/test_inet_diag_socket.rb 

RUBYOPT="-Ilib -I%{buildroot}%{gem_extdir} -Itest" testrb test/test_last_data_recv_unicorn.rb

RUBYOPT="-Ilib -I%{buildroot}%{gem_extdir} -Itest" testrb test/test_linux_all_tcp_listen_stats_leak.rb

RUBYOPT="-Ilib -I%{buildroot}%{gem_extdir} -Itest" testrb test/test_linux_all_tcp_listen_stats.rb

RUBYOPT="-Ilib -I%{buildroot}%{gem_extdir} -Itest" testrb test/test_linux_middleware.rb

RUBYOPT="-Ilib -I%{buildroot}%{gem_extdir} -Itest" testrb test/test_linux.rb

RUBYOPT="-Ilib -I%{buildroot}%{gem_extdir} -Itest" testrb test/test_linux_tcp_info.rb

RUBYOPT="-Ilib -I%{buildroot}%{gem_extdir} -Itest" testrb test/test_middleware.rb

#RUBYOPT="-Ilib -I{buildroot}{gem_extdir} -Itest" testrb test/test_middleware_unicorn_ipv6.rb

#RUBYOPT="-Ilib -I{buildroot}{gem_extdir} -Itest" testrb test/test_middleware_unicorn.rb

RUBYOPT="-Ilib -I%{buildroot}%{gem_extdir} -Itest" testrb test/test_raindrops_gc.rb

RUBYOPT="-Ilib -I%{buildroot}%{gem_extdir} -Itest" testrb test/test_raindrops.rb

RUBYOPT="-Ilib -I%{buildroot}%{gem_extdir} -Itest" testrb test/test_raindrops.rb

RUBYOPT="-Ilib -I%{buildroot}%{gem_extdir} -Itest" testrb test/test_struct.rb

# Tests in troubles
#RUBYOPT="-Ilib -I {buildroot} {gem_extdir} -Itest" testrb test/test_watcher.rb
#RUBYOPT="-Ilib -I {buildroot} {gem_extdir} -Itest" testrb test/test_linux_ipv6.rb

%files
%{gem_extdir}
%doc %{gem_instdir}/README
%doc %{gem_instdir}/LICENSE
%doc %{gem_instdir}/COPYING
%dir %{gem_instdir}
%{gem_instdir}/lib
%{gem_cache}
%{gem_spec} 

%files doc
%doc %{gem_dir}/doc/%{gem_name}-%{version}
%doc %{gem_instdir}/NEWS
%doc %{gem_instdir}/LATEST
%doc %{gem_instdir}/TODO
%doc %{gem_instdir}/ChangeLog
%doc %{gem_instdir}/examples
%doc %{gem_instdir}/test
%doc %{gem_libdir}/raindrops.rb
%doc %{gem_libdir}/raindrops/aggregate.rb
%doc %{gem_libdir}/raindrops/aggregate/last_data_recv.rb
%doc %{gem_libdir}/raindrops/aggregate/pmq.rb
%doc %{gem_libdir}/raindrops/last_data_recv.rb
%doc %{gem_libdir}/raindrops/linux.rb
%doc %{gem_libdir}/raindrops/middleware.rb
%doc %{gem_libdir}/raindrops/middleware/proxy.rb
%doc %{gem_libdir}/raindrops/struct.rb
%doc %{gem_libdir}/raindrops/watcher.rb


%changelog
* Sat Jul 21 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.8.0-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Fri Feb 10 2012 Guillermo Gómez <guillermo.gomez@gmail.com> - 0.8.0-5
- Fixed spec file for Fedora Ruby 1.9 packaging guidelines

* Wed Feb 08 2012 Guillermo Gómez <guillermo.gomez@gmail.com> - 0.8.0-4
- Spec file adjusted for Fedora Ruby 1.9 packaging guidelines

* Sun Jan 22 2012 Guillermo Gómez <guillermo.gomez@gmail.com> - 0.8.0-3
- C extension moved to richt place

* Sun Jan 22 2012 Guillermo Gómez <guillermo.gomez@gmail.com> - 0.8.0-2
- License field fixed

* Sun Jan 08 2012 Guillermo Gómez <guillermo.gomez@gmail.com> - 0.8.0-1
- Initial package
